#pragma once
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>

static void err(int eval,const char *fmt,...) {
	printf("error: ");
	va_list vl;
    va_start(vl,fmt);
	vfprintf(stderr,fmt,vl);
	if(fmt) printf(": %s",strerror(errno));
	printf("\n");
}

static void errx(int eval,const char *fmt,...) {
	printf("error: ");
	va_list vl;
    va_start(vl,fmt);
	vfprintf(stderr,fmt,vl);
	printf("\n");
}
	