			include "propeller.i"
			include "demo.i"

PINMASK		=	$30
EXITTIME	=	1030

			org	0

			mov	t1, #DITHER_HALF
			wrbyte	t1, =@ditherstyle		' In preparation of the spinner
			wrlong	half_frontback, =@backbuf	' In preparation of the spinner

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			add	frame, #1

			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	VSCL, =620
			waitvid	zero, #0

			mov	ypos, =160

			mov	sin_a, frame
			shl	sin_a, #5
			max	sin_a, =$7ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	t1, sin_a
			shr	t1, #8
			sub	ypos, t1

			mov	sin_a, frame
			sub	sin_a, =EXITTIME	wc
		if_c	jmp	#:noexit

			shl	sin_a, #5
			max	sin_a, =$7ff
			xor	sin_a, =$7ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	t1, sin_a
			shr	t1, #8
			sub	ypos, #255
			add	ypos, t1
:noexit
			mov	y, #240
vline
			mov	t1, ypos
			max	t1, #44
			mov	addr, t1
			shl	addr, #4
			sub	addr, t1
			shl	addr, #2
			add	addr, PAR	' addr = PAR + 60 * ypos

			mov	VSCL, =16 << 12 | 256
			mov	x, #15
:xloop
			rdlong	bits, addr
			add	addr, #4
			waitvid	palette, bits
			djnz	x, #:xloop

			mov	VSCL, =1240
			waitvid	zero, #0

			add	ypos, #1
			djnz	y, #vline

			movs	VCFG, #0
			jmp	#vbl

palette			byte	$00, $10, $20, $30

half_frontback		word	@graphics0h, @graphics1h

			pool

frame			long	0

addr			res	1
t1			res	1
t2			res	1
x			res	1
y			res	1
ypos			res	1
bits			res	1
sin_a			res	1

			vfit	496
