#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <math.h>

#ifdef _WIN32
  #include <io.h>
  #include <fcntl.h>
#endif

int main() {
	#ifdef _WIN32
	_setmode(fileno(stdout), O_BINARY);
#endif
	int x, m, s;
	double angle, dim;

	for(x = 0; x < 256; x++) {
		angle = asin((double) (x - 128) / 128);

		s = ((int) round(angle * 16)) & 15;

		dim = sin(x * M_PI / 255);
		dim += (double) (rand() & 127) * .5 / 127;
		if(dim < .5) {
			m = 1;
		} else if(dim < 1) {
			m = 2;
		} else {
			m = 3;
		}

		fputc((s << 4) | (m << 2), stdout);
	}

	return 0;
}
