			include "propeller.i"
			include "demo.i"

PINMASK		=	$04
XPOS		=	1170
START		=	2200

			org	0

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	VSCL, =2540
			mov	y, =(146 + 12) * 2
:lp			waitvid	zero, #0
			djnz	y, #:lp

			mov	fontline, #32*4
			mov	t1, spread
			add	t1, #10
			andn	t1, #3
			maxs	t1, #32*4
			sub	fontline, t1

			mov	y, #32
vline
			cmp	fontline, #32*4		wc wz
		if_ae	jmp	#done

			mov	VSCL, =620+XPOS
			mov	t1, spread
			mins	t1, #0
			andn	t1, #3
			sub	VSCL, t1
			mov	t1, xadjust
			shr	t1, #8
			add	VSCL, t1
			waitvid	zero, #0

			mov	addr, =$8000
			add	addr, fontline

			movs	p_char, #string

			mov	x, #8
			mov	VSCL, =12 << 12 | 192
			mov	t1, spread
			mins	t1, #0
			shr	t1, #2
			add	VSCL, t1
xloop
p_char			mov	t1, 000
			shr	t1, #1		wc
			shl	t1, #7
			add	t1, addr
			rdlong	bits, t1
		if_c	shr	bits, #1

			waitvid	palette, bits

			add	p_char, #1
			djnz	x, #xloop

			mov	VSCL, =2412+64*8-XPOS
			mov	t1, spread
			mins	t1, #0
			andn	t1, #3
			sub	VSCL, t1
			mov	t1, xadjust
			shr	t1, #8
			sub	VSCL, t1
			waitvid	zero, #0

			add	fontline, #4
			djnz	y, #vline
done
			movs	VCFG, #0
			add	spread, #2
			add	xadjust, #28
			jmp	#vbl

palette			byte	0, PINMASK, 0, PINMASK

string			long	$70, $72, $65, $73, $65, $6e, $74, $73

			pool

spread			long	0 - START
xadjust			long	0 - START * 14

addr			res	1
t1			res	1
t2			res	1
x			res	1
y			res	1
bits			res	1
fontline		res	1

			vfit	496
